Subject: bug#46594: [External] : bug#46594: Use short answers

From: Drew Adams <[email-masked]>
Date: Mon, 22 Feb 2021 17:13:28 +0000

> > As discussed in
> > https://urldefense.com/v3/__https://lists.gnu.org/archive/html/emacs-
> devel/2020-12/msg01915.html__;!!GqivPVa7Brio!PKOEWigE5iDrORKbgYbHKSe-
> DDgDExr74sBYZX3qybMC-I407gDeDkA8tD-MtISo$
> > here is an option that accomplishes the mapping of
> > (defalias 'yes-or-no-p 'y-or-n-p)
> 
> Makes sense to me -- having a variable instead of this extremely common
> defalias is better design.

Is it?  Jaywalking is extremely common (and I'm a major offender), but it's against the law for a reason: saves lives.  Speeding is extremely common, but speed limits are there for a reason.  Etc.

> > This is a related option, but I'm not sure if it should be mentioned
> > in the docstring.  Maybe a simple reference should be sufficient?
> 
> I think mentioning it in the `yes-or-no-p' doc string would be good.

I think that the doc for this option should explicitly discourage using the value that abbreviates, and say why.

It should say that `yes-or-no-p' is _intended_ to be used when it's thought that you should not respond too quickly.  At least point that out, for users to think about before customizing.

Otherwise, we're, in effect, encouraging `y-or-n-p' behavior, in the end.  There's a reason Emacs has two such UIs.

Yes, whoever writes code that uses one of them might sometimes use judgment that a given user might disagree with.  But this option doesn't affect just one or two poor uses of such a function - it affects all of them.

Presumably this option is being added because there are apparently a lot of users who don't want to be slowed down by `yes-or-no-p'.  But that's exactly the point of `yes-or-no-p'.  

Users who really want to always get `y-or-n-p' behavior have gone to the trouble of adding an alias.  That's not a lot of trouble.  Maybe the fact that they've had to jump that extra hurdle was a good, not a bad, thing?

Users can turn off automatic backup of files, and all kinds of things that they might find as bothersome or cumbersome.  Such things are there to protect us from shooting ourselves in the foot - by default.  It's fine to have user options to turn off such protection (we have option `make-backup-files', for instance.  But it can also be a good idea for the doc to point out the possible downsides.